]> git.saurik.com Git - apt.git/blame - test/integration/framework
test: Use SHA512 digests for GPG, reject SHA1-based signatures
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
68042532
DK
5while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
61e92778
DK
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
68042532
DK
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24done
25export MSGLEVEL="${MSGLEVEL:-3}"
26
8d876415 27# we all like colorful messages
61e92778 28if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
27cb4f6c 29 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
30 export MSGCOLOR='NO'
31 fi
32fi
33
34
35if [ "$MSGCOLOR" != 'NO' ]; then
36 CERROR="\033[1;31m" # red
37 CWARNING="\033[1;33m" # yellow
38 CMSG="\033[1;32m" # green
39 CINFO="\033[1;96m" # light blue
40 CDEBUG="\033[1;94m" # blue
41 CNORMAL="\033[0;39m" # default system console color
42 CDONE="\033[1;32m" # green
43 CPASS="\033[1;32m" # green
44 CFAIL="\033[1;31m" # red
45 CCMD="\033[1;35m" # pink
682a3bf7 46fi
8d876415 47
de81b2e2
DK
48msgprintf() {
49 local START="$1"
50 local MIDDLE="$2"
51 local END="$3"
52 shift 3
53 if [ -n "$1" ]; then
54 printf "$START " "$1"
d73840dc 55 shift
de81b2e2 56 while [ -n "$1" ]; do
bc8f83a5 57 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
de81b2e2
DK
58 shift
59 done
60 fi
61 printf "${END}"
2a2a7ef4 62}
de81b2e2
DK
63msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
64msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
65msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
66msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
67msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
68msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
69msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
70msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
71msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
72msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
73msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
3c528b91 74msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
1501a2c9 75msgreportheader() {
68042532 76 if [ -n "$MSGTEST_MSG" ]; then
1501a2c9 77 test "$1" != 'msgfailoutput' || echo
ae7fce5a
DK
78 if [ -n "$MSGTEST_MSGMSG" ]; then
79 echo "$MSGTEST_MSGMSG"
80 fi
22ac12b2 81 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
1501a2c9 82 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
22ac12b2 83 fi
68042532
DK
84 echo -n "$MSGTEST_MSG"
85 unset MSGTEST_MSG
86 fi
1501a2c9
DK
87}
88msgskip() {
89 msgreportheader 'msgskip'
68ba0b7f
DK
90 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
91 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
92}
5229b285 93msgfail() {
1501a2c9 94 msgreportheader 'msgfail'
68042532 95 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
3c528b91 96 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
03aa0847 97 if [ -n "$APT_DEBUG_TESTS" ]; then
896f0ae8 98 runapt $SHELL
03aa0847 99 fi
5229b285
DK
100 EXIT_CODE=$((EXIT_CODE+1));
101}
9beb11aa
DK
102MSGGROUP_LEVEL=0
103msggroup() {
104 if [ -n "$1" ]; then
105 if [ $MSGGROUP_LEVEL = 0 ]; then
106 MSGTEST_GRP='NEXT'
107 fi
108 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
109 else
110 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
111 if [ $MSGGROUP_LEVEL = 0 ]; then
112 unset MSGTEST_GRP
113 fi
114 fi
115}
8d876415
DK
116
117# enable / disable Debugging
fc89263e
DK
118if [ $MSGLEVEL -le 0 ]; then
119 msgdie() { true; }
120fi
121if [ $MSGLEVEL -le 1 ]; then
122 msgwarn() { true; }
123 msgnwarn() { true; }
124fi
125if [ $MSGLEVEL -le 2 ]; then
ae7fce5a
DK
126 msgmsg() {
127 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
128 }
fc89263e 129 msgnmsg() { true; }
9beb11aa
DK
130 msgtest() {
131 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
132 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
133 MSGTEST_GRP="$MSGTEST_MSG"
134 fi
135 }
3c528b91 136 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
fc89263e
DK
137fi
138if [ $MSGLEVEL -le 3 ]; then
139 msginfo() { true; }
140 msgninfo() { true; }
141fi
142if [ $MSGLEVEL -le 4 ]; then
143 msgdebug() { true; }
144 msgndebug() { true; }
145fi
146msgdone() {
147 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
148 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
149 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
150 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
151 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
152 true;
153 else
3c528b91 154 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
155 fi
156}
e43a426e
MV
157getaptconfig() {
158 if [ -f ./aptconfig.conf ]; then
5465192b 159 echo "$(readlink -f ./aptconfig.conf)"
e43a426e 160 elif [ -f ../aptconfig.conf ]; then
5465192b
DK
161 echo "$(readlink -f ../aptconfig.conf)"
162 elif [ -f ../../aptconfig.conf ]; then
163 echo "$(readlink -f ../../aptconfig.conf)"
164 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
165 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
166 fi
e43a426e 167}
8d876415
DK
168runapt() {
169 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
170 local CMD="$1"
171 shift
3abb6a6a 172 case "$CMD" in
a311fb96 173 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
174 *) CMD="${BUILDDIRECTORY}/$CMD";;
175 esac
896f0ae8 176 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
8d876415 177}
846856f4
DK
178aptconfig() { runapt apt-config "$@"; }
179aptcache() { runapt apt-cache "$@"; }
180aptcdrom() { runapt apt-cdrom "$@"; }
181aptget() { runapt apt-get "$@"; }
182aptftparchive() { runapt apt-ftparchive "$@"; }
183aptkey() { runapt apt-key "$@"; }
184aptmark() { runapt apt-mark "$@"; }
4f6d26b4 185aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 186apt() { runapt apt "$@"; }
3b8eb3bc
DK
187apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
188aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
189aptitude() { runapt aptitude "$@"; }
8d50b63f 190aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 191aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
ad7e0941 192aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
3b8eb3bc 193
158fda31 194dpkg() {
b0be0e09 195 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
158fda31 196}
ce7f128c 197dpkgcheckbuilddeps() {
63c71412 198 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
b6b5a542 199}
3fa950f1 200gdb() {
b07aeb1a
DK
201 local CMD
202 case "$1" in
203 aptget) CMD="apt-get";;
204 aptcache) CMD="apt-cache";;
5465192b
DK
205 aptcdrom) CMD="apt-cdrom";;
206 aptconfig) CMD="apt-config";;
b07aeb1a
DK
207 aptmark) CMD="apt-mark";;
208 apthelper) CMD="apt-helper";;
3d8232bf 209 aptftparchive) CMD="apt-ftparchive";;
63c71412 210 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
b07aeb1a
DK
211 *) CMD="$1";;
212 esac
ce928105 213 shift
921a9626
DK
214 if [ "${CMD##*/}" = "$CMD" ]; then
215 CMD="${BUILDDIRECTORY}/${CMD}"
216 fi
217 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
ae99ce2e 218}
8d876415 219
8c1dd12c 220exitwithstatus() {
f91bd741
MV
221 # error if we about to overflow, but ...
222 # "255 failures ought to be enough for everybody"
5d76cee1
MV
223 if [ $EXIT_CODE -gt 255 ]; then
224 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 225 fi
5d76cee1 226 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
227}
228
804d4a0d
DK
229shellsetedetector() {
230 local exit_status=$?
231 if [ "$exit_status" != '0' ]; then
3c528b91 232 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
233 if [ "$EXIT_CODE" = '0' ]; then
234 EXIT_CODE="$exit_status"
235 fi
236 fi
237}
238
b720d0bd 239addtrap() {
8437b7d4
DK
240 if [ "$1" = 'prefix' ]; then
241 CURRENTTRAP="$2 $CURRENTTRAP"
242 else
243 CURRENTTRAP="$CURRENTTRAP $1"
244 fi
804d4a0d 245 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 246}
8d876415 247
bc8f83a5
DK
248escape_shell() {
249 echo "$@" | sed -e "s#'#'\"'\"'#g"
250}
251
8d876415 252setupenvironment() {
0d303f17
DK
253 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
254 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
255 unset TMPDIR
256 fi
63c71412 257 TMPWORKINGDIRECTORY="$(mktemp -d)"
bc8f83a5
DK
258 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
259 if [ -n "$TMPDIR_ADD" ]; then
260 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
261 mkdir -p "$TMPWORKINGDIRECTORY"
262 unset TMPDIR_ADD
263 export TMPDIR="$TMPWORKINGDIRECTORY"
264 fi
63c71412 265 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
5c0dd6fc 266
03aa0847 267 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
268 if [ "$(id -u)" = '0' ]; then
269 # relax permissions so that running as root with user switching works
270 umask 022
03aa0847
DK
271 chmod 711 "$TMPWORKINGDIRECTORY"
272 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
273 fi
274
63c71412 275 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
5c0dd6fc 276 # allow overriding the default BUILDDIR location
63c71412
DK
277 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
278 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}"
279 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}"
280 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}"
281 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
282 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}"
283 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}"
284 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}"
8d876415 285 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
286 # -----
287
63c71412 288 cd "$TMPWORKINGDIRECTORY"
cd725954 289 mkdir rootdir aptarchive keys
8d876415 290 cd rootdir
b29c3712 291 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
8fe964f1 292 mkdir -p usr/bin var/cache var/lib var/log tmp
cffea9af 293 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 294 touch var/lib/dpkg/available
8d876415 295 mkdir -p usr/lib/apt
63c71412 296 ln -s "${METHODSDIR}" usr/lib/apt/methods
1f6cf9e7
DK
297 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
298 mkdir -p usr/lib/apt/solvers
299 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
300 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
301 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
302 fi
291a386f
MV
303 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
304 # system
63c71412
DK
305 if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then
306 ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
291a386f
MV
307 else
308 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
309 fi
8d876415 310 cd ..
63c71412
DK
311 local BASENAME="${0##*/}"
312 local PACKAGESFILE="Packages-${BASENAME#*-}"
53ea1b56
DK
313 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
314 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 315 fi
63c71412 316 local SOURCESSFILE="Sources-${BASENAME#*-}"
53ea1b56
DK
317 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
318 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 319 fi
3abb6a6a
DK
320 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
321 chmod 644 keys/*
63c71412 322 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 323
cffea9af 324 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 325 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415 326 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
9d2a8a73 327 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
23e64f6d
DK
328 # either store apt-key were we can access it, even if we run it as a different user
329 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
330 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
331 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
332 # destroys coverage reporting though, so we disable changing user for the calling gpgv
333 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
68ba0b7f 334 if [ "$(id -u)" = '0' ]; then
23e64f6d 335 echo 'Binary::gpgv::Debug::NoDropPrivs "true";' >>aptconfig.conf
68ba0b7f 336 fi
b0be0e09 337
63c71412 338 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
b0be0e09
DK
339#!/bin/sh
340set -e
3abb6a6a 341if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
63c71412 342 if [ -n "\$LD_LIBRARY_PATH" ]; then
3abb6a6a 343 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
b0be0e09 344 else
3abb6a6a 345 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
b0be0e09 346 fi
921a9626 347 if [ -n "\$LD_PRELOAD" ]; then
63c71412 348 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
921a9626 349 else
63c71412 350 export LD_PRELOAD="noopchroot.so"
921a9626
DK
351 fi
352fi
63c71412
DK
353EOF
354 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
355 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
3abb6a6a
DK
356exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
357 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
63c71412
DK
358 --force-not-root --force-bad-path "\$@"
359EOF
360 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
3abb6a6a
DK
361exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
362 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
b0be0e09
DK
363 --force-not-root --force-bad-path "\$@"
364EOF
921a9626 365 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
b0be0e09
DK
366 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
367
533fe3d1
DK
368 {
369 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
370 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
371 fi
87d6947d 372 echo 'quiet "0";'
533fe3d1
DK
373 echo 'quiet::NoUpdate "true";'
374 echo 'quiet::NoStatistic "true";'
375 # too distracting for users, but helpful to detect changes
376 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
377 echo 'Acquire::Progress::Diffpercent "true";'
378 # in testcases, it can appear as if localhost has a rotation setup,
379 # hide this as we can't really deal with it properly
380 echo 'Acquire::Failure::ShowIP "false";'
ebca2f25
DK
381 # fakeroot can't fake everything, so disabled in production but good for tests
382 echo 'APT::Sandbox::Verify "true";'
533fe3d1 383 } >> aptconfig.conf
d6cf2345 384
68ba0b7f
DK
385 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
386 if [ "$(id -u)" = '0' ]; then
387 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
388 fi
389 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 390 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
23d35ec1 391 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
493a813e
JAK
392 if aptkey verify --weak-digest SHA1 --help 2>/dev/null >/dev/null; then
393 echo 'Acquire::gpgv::Options { "--weak-digest"; "sha1"; };' > rootdir/etc/apt/apt.conf.d/no-sha1
394 fi
395
276e51dd 396 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
51c04562 397 confighashes 'SHA256' # these are tests, not security best-practices
77a45beb 398
4bb006d1 399 # create some files in /tmp and look at user/group to get what this means
eab57e08 400 TEST_DEFAULT_USER="$(id -un)"
4bb006d1
DK
401 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
402 TEST_DEFAULT_GROUP='root'
403 else
eab57e08 404 TEST_DEFAULT_GROUP="$(id -gn)"
4bb006d1
DK
405 fi
406
ce7f128c 407 # cleanup the environment a bit
995a4bf6 408 # prefer our apt binaries over the system apt binaries
8c617819 409 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
be233796 410 export LC_ALL=C.UTF-8
3b8eb3bc 411 unset LANGUAGE APT_CONFIG
ce7f128c 412 unset GREP_OPTIONS DEB_BUILD_PROFILES
59f57473 413 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
8d876415
DK
414 msgdone "info"
415}
416
ea65d079
DK
417getarchitecture() {
418 if [ "$1" = "native" -o -z "$1" ]; then
419 eval `aptconfig shell ARCH APT::Architecture`
420 if [ -n "$ARCH" ]; then
421 echo $ARCH
422 else
5834d7a1 423 dpkg --print-architecture
ea65d079
DK
424 fi
425 else
426 echo $1
427 fi
428}
429
53ea1b56 430getarchitectures() {
081c9d44 431 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
53ea1b56
DK
432}
433
3dcdc1f9
DK
434getarchitecturesfromcommalist() {
435 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
436}
437
8d876415 438configarchitecture() {
18908589
DK
439 {
440 echo "APT::Architecture \"$(getarchitecture $1)\";"
441 while [ -n "$1" ]; do
442 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
443 shift
444 done
445 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
446 configdpkg
447}
448
449configdpkg() {
450 if [ ! -e rootdir/var/lib/dpkg/status ]; then
63c71412
DK
451 local BASENAME="${0##*/}"
452 local STATUSFILE="status-${BASENAME#*-}"
53ea1b56
DK
453 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
454 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
455 else
456 echo -n > rootdir/var/lib/dpkg/status
457 fi
458 fi
18908589 459 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 460 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
461 local ARCHS="$(getarchitectures)"
462 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
463 DPKGARCH="$(dpkg --print-architecture)"
464 for ARCH in ${ARCHS}; do
feae193b 465 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 466 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 467 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
468 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
469 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
470 fi
471 fi
53ea1b56
DK
472 done
473 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
474 # dpkg doesn't really check the version as long as it is fully installed,
475 # but just to be sure we choose one above the required version
476 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
477 fi
478 fi
479 fi
8d876415
DK
480}
481
0c787570
DK
482configdpkgnoopchroot() {
483 # create a library to noop chroot() and rewrite maintainer script executions
484 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
485 # chroot directory dpkg could chroot into to execute the maintainer scripts
486 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
63c71412 487 cat > noopchroot.c << EOF
0c787570
DK
488#define _GNU_SOURCE
489#include <stdio.h>
490#include <stdlib.h>
491#include <string.h>
492#include <dlfcn.h>
493
494static char * chrootdir = NULL;
495
496int chroot(const char *path) {
497 printf("WARNING: CHROOTing to %s was ignored!\n", path);
498 free(chrootdir);
499 chrootdir = strdup(path);
500 return 0;
501}
502int execvp(const char *file, char *const argv[]) {
503 static int (*func_execvp) (const char *, char * const []) = NULL;
504 if (func_execvp == NULL)
505 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
506 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
507 return func_execvp(file, argv);
508 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
950733c9
JAK
509 char *newfile;
510 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
511 perror("asprintf");
512 return -1;
513 }
b0be0e09 514 char const * const baseadmindir = "/var/lib/dpkg";
950733c9
JAK
515 char *admindir;
516 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
517 perror("asprintf");
518 return -1;
519 }
b0be0e09 520 setenv("DPKG_ADMINDIR", admindir, 1);
0c787570
DK
521 return func_execvp(newfile, argv);
522}
523EOF
a66e1837 524 testempty --nomsg gcc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c -ldl
0c787570 525}
276e51dd 526configcompression() {
abec2980 527 local CMD='apthelper cat-file -C'
276e51dd
DK
528 while [ -n "$1" ]; do
529 case "$1" in
3c528b91 530 '.') printf ".\t.\tcat\n";;
abec2980
DK
531 'gz') printf "gzip\tgz\t$CMD $1\n";;
532 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
533 *) printf "$1\t$1\t$CMD $1\n";;
276e51dd
DK
534 esac
535 shift
63c71412 536 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
276e51dd 537}
c5ede4ca
DK
538confighashes() {
539 {
540 echo 'APT::FTPArchive {'
541 {
542 while [ -n "$1" ]; do
543 printf "$1" | tr 'a-z' 'A-Z'
544 printf "\t\"true\";\n"
545 shift
546 done
547 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
548 printf "$h\t\"false\";\n"
549 done
550 } | awk '!x[$1]++'
551 echo '};'
552 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
553}
5f982b9d
DK
554forcecompressor() {
555 COMPRESSOR="$1"
912a6131 556 COMPRESS="$1"
abec2980 557 COMPRESSOR_CMD="apthelper cat-file -C $1"
5f982b9d
DK
558 case $COMPRESSOR in
559 gzip) COMPRESS='gz';;
560 bzip2) COMPRESS='bz2';;
5f982b9d
DK
561 esac
562 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
563 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
912a6131 564Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
5f982b9d
DK
565}
566
75954ae2 567setupsimplenativepackage() {
ce9864a8
DK
568 local NAME="$1"
569 local ARCH="$2"
570 local VERSION="$3"
571 local RELEASE="${4:-unstable}"
572 local DEPENDENCIES="$5"
14109555 573 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
574 If you find such a package installed on your system,
575 something went horribly wrong! They are autogenerated
3d284148 576 und used only by testcases and serve no other purpose…"}"
18908589 577
b7899b00
DK
578 local SECTION="${7:-others}"
579 local DISTSECTION
63c71412 580 if [ "$SECTION" = "${SECTION#*/}" ]; then
b7899b00
DK
581 DISTSECTION="main"
582 else
63c71412 583 DISTSECTION="${SECTION%/*}"
b7899b00 584 fi
ce9864a8
DK
585 local BUILDDIR=incoming/${NAME}-${VERSION}
586 mkdir -p ${BUILDDIR}/debian/source
587 cd ${BUILDDIR}
588 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
589 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
590 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
591
592 * Initial release
593
b7899b00
DK
594 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
595 test -e debian/control || echo "Source: $NAME
596Section: $SECTION
ce9864a8
DK
597Priority: optional
598Maintainer: Joe Sixpack <joe@example.org>
599Build-Depends: debhelper (>= 7)
600Standards-Version: 3.9.1
601
875bcb36
DK
602Package: $NAME" > debian/control
603 if [ "$ARCH" = 'all' ]; then
604 echo "Architecture: all" >> debian/control
605 else
606 echo "Architecture: any" >> debian/control
607 fi
ce9864a8 608 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
609 echo "Description: $DESCRIPTION" >> debian/control
610
b7899b00
DK
611 test -e debian/compat || echo "7" > debian/compat
612 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 613 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
614 cd - > /dev/null
615}
616
617buildsimplenativepackage() {
618 local NAME="$1"
d56e2917
DK
619 local NM
620 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
621 NM="$(echo "$NAME" | cut -c 1-4)"
622 else
623 NM="$(echo "$NAME" | cut -c 1)"
624 fi
75954ae2
DK
625 local ARCH="$2"
626 local VERSION="$3"
627 local RELEASE="${4:-unstable}"
628 local DEPENDENCIES="$5"
14109555 629 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
630 If you find such a package installed on your system,
631 something went horribly wrong! They are autogenerated
3d284148 632 und used only by testcases and serve no other purpose…"}"
18908589 633
75954ae2 634 local SECTION="${7:-others}"
d67004e0 635 local PRIORITY="${8:-optional}"
63c71412
DK
636 local FILE_TREE="$9"
637 local COMPRESS_TYPE="${10:-gzip}"
75954ae2 638 local DISTSECTION
63c71412 639 if [ "$SECTION" = "${SECTION#*/}" ]; then
75954ae2
DK
640 DISTSECTION="main"
641 else
63c71412 642 DISTSECTION="${SECTION%/*}"
75954ae2 643 fi
63c71412 644 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
b761356f 645
0c787570 646 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
63c71412
DK
647 mkdir -p "$BUILDDIR/debian/source"
648 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
b761356f 649 echo "#!/bin/sh
63c71412 650echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
b761356f 651
63c71412 652 echo "Copyleft by Joe Sixpack $(date +%Y)" > "${BUILDDIR}/debian/copyright"
b761356f
DK
653 echo "$NAME ($VERSION) $RELEASE; urgency=low
654
655 * Initial release
656
63c71412
DK
657 -- Joe Sixpack <joe@example.org> $(date -R)" > "${BUILDDIR}/debian/changelog"
658 {
659 echo "Source: $NAME
d67004e0 660Priority: $PRIORITY
b761356f 661Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
662Standards-Version: 3.9.3"
663 if [ "$SECTION" != '<none>' ]; then
664 echo "Section: $SECTION"
665 fi
666 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
667 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
668 echo "
669Package: $NAME"
b761356f 670
63c71412
DK
671 if [ "$ARCH" = 'all' ]; then
672 echo "Architecture: all"
673 else
674 echo "Architecture: any"
675 fi
676 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
677 test -z "$DEPS" || echo "$DEPS"
678 echo "Description: $DESCRIPTION"
679 } > "${BUILDDIR}/debian/control"
01f520ce 680
63c71412
DK
681 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
682 cd "${BUILDDIR}/.."
0c787570
DK
683 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
684 cd - >/dev/null
63c71412 685 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
f1828b69 686 | while read SRC; do
63c71412 687 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
f1828b69 688# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 689# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 690# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
691# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
692# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
693# fi
b761356f 694 done
84aa13f4 695
3dcdc1f9 696 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
0c787570 697 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
63c71412
DK
698 rm -rf "${BUILDDIR}/debian/tmp"
699 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
700 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
701 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
42c1513b 702 if [ -n "$FILE_TREE" ]; then
63c71412 703 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
42c1513b 704 fi
42c1513b 705
63c71412
DK
706 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
707 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 708 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
d56e2917 709 # ensure the right permissions as dpkg-deb insists
63c71412
DK
710 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
711 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
712 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
84aa13f4
DK
713 done
714
d56e2917 715 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
63c71412
DK
716 mkdir -p "$CHANGEPATH"
717 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
5a635ee4 718 rm -rf "${BUILDDIR}"
b761356f 719 msgdone "info"
75954ae2
DK
720}
721
722buildpackage() {
723 local BUILDDIR=$1
724 local RELEASE=$2
725 local SECTION=$3
ea65d079 726 local ARCH=$(getarchitecture $4)
846856f4
DK
727 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
728 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
0c787570 729 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
63c71412 730 cd "$BUILDDIR"
75954ae2
DK
731 if [ "$ARCH" = "all" ]; then
732 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
733 fi
0c787570 734 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
63c71412
DK
735 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
736 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
737 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 738 cd - > /dev/null
b7899b00 739 for PKG in $PKGS; do
63c71412 740 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
b7899b00
DK
741 done
742 for SRC in $SRCS; do
63c71412 743 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
b7899b00 744 done
ce9864a8
DK
745}
746
747buildaptarchive() {
ce9864a8 748 if [ -d incoming ]; then
846856f4 749 buildaptarchivefromincoming "$@"
ce9864a8 750 else
846856f4 751 buildaptarchivefromfiles "$@"
ce9864a8
DK
752 fi
753}
754
755createaptftparchiveconfig() {
63c71412 756 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
016bea82
DK
757 local COMPRESSORS="${COMPRESSORS%* }"
758 local ARCHS="$(getarchitectures)"
c5ede4ca
DK
759 cat > ftparchive.conf <<EOF
760Dir {
761 ArchiveDir "$(readlink -f .)";
762 CacheDir "$(readlink -f ..)";
763 FileListDir "$(readlink -f pool/)";
b7899b00
DK
764};
765Default {
c5ede4ca
DK
766 Packages::Compress "$COMPRESSORS";
767 Sources::Compress "$COMPRESSORS";
768 Contents::Compress "$COMPRESSORS";
769 Translation::Compress "$COMPRESSORS";
18331adf 770 LongDescription "false";
ce9864a8
DK
771};
772TreeDefault {
773 Directory "pool/";
774 SrcDirectory "pool/";
775};
c5ede4ca 776EOF
b7899b00 777 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
63c71412
DK
778 cat <<EOF
779tree "dists/$DIST" {
1dd20368 780 Architectures "$ARCHS all source";
63c71412
DK
781 FileList "${DIST}.\$(SECTION).pkglist";
782 SourceFileList "${DIST}.\$(SECTION).srclist";
783 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
784};
785EOF
786 done >> ftparchive.conf
ce9864a8
DK
787}
788
789buildaptftparchivedirectorystructure() {
b7899b00
DK
790 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
791 for DIST in $DISTS; do
792 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
793 for SECTION in $SECTIONS; do
794 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
795 for ARCH in $ARCHS; do
63c71412 796 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
b7899b00 797 done
63c71412
DK
798 mkdir -p "dists/${DIST}/${SECTION}/source"
799 mkdir -p "dists/${DIST}/${SECTION}/i18n"
b7899b00 800 done
ce9864a8 801 done
ce9864a8
DK
802}
803
9b78cda6 804insertpackage() {
10e100e5 805 local RELEASES="$1"
9b78cda6
DK
806 local NAME="$2"
807 local ARCH="$3"
808 local VERSION="$4"
809 local DEPENDENCIES="$5"
d67004e0 810 local PRIORITY="${6:-optional}"
10e100e5 811 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
18908589
DK
812 If you find such a package installed on your system,
813 something went horribly wrong! They are autogenerated
3d284148 814 und used only by testcases and serve no other purpose…"}"
d67004e0 815 local ARCHS=""
10e100e5
DK
816 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
817 if [ "$RELEASE" = 'installed' ]; then
818 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
819 continue
d67004e0 820 fi
10e100e5 821 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
1dd20368 822 if [ "$arch" = 'none' ]; then
10e100e5
DK
823 ARCHS="$(getarchitectures)"
824 else
825 ARCHS="$arch"
826 fi
827 for BUILDARCH in $ARCHS; do
828 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
63c71412
DK
829 mkdir -p "$PPATH"
830 {
831 echo "Package: $NAME
d67004e0 832Priority: $PRIORITY
9b78cda6 833Section: other
2c085486 834Installed-Size: 42
63c71412
DK
835Maintainer: Joe Sixpack <joe@example.org>"
836 test "$arch" = 'none' || echo "Architecture: $arch"
837 echo "Version: $VERSION
838Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
839 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES"
840 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
841 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
842 echo
843 } >> "${PPATH}/Packages"
10e100e5 844 done
d67004e0 845 done
63c71412
DK
846 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
847 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
10e100e5 848 echo "Package: $NAME
0e0d9919
DK
849Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
850Description-en: $DESCRIPTION
63c71412 851" >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
10e100e5 852 done
9b78cda6
DK
853}
854
234675b7 855insertsource() {
07aca07a 856 local RELEASES="$1"
234675b7
DK
857 local NAME="$2"
858 local ARCH="$3"
859 local VERSION="$4"
860 local DEPENDENCIES="$5"
07aca07a 861 local BINARY="${6:-$NAME}"
234675b7 862 local ARCHS=""
07aca07a
DK
863 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
864 local SPATH="aptarchive/dists/${RELEASE}/main/source"
865 mkdir -p $SPATH
866 local FILE="${SPATH}/Sources"
867 local DSCFILE="${NAME}_${VERSION}.dsc"
868 local TARFILE="${NAME}_${VERSION}.tar.gz"
869 echo "Package: $NAME
a8275acf 870Binary: $BINARY
234675b7
DK
871Version: $VERSION
872Maintainer: Joe Sixpack <joe@example.org>
873Architecture: $ARCH" >> $FILE
07aca07a
DK
874 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
875 echo "Files:
63c71412
DK
876 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
877 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
55ae7a51 878Checksums-Sha256:
63c71412
DK
879 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
880 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
881" >> "$FILE"
07aca07a 882 done
234675b7
DK
883}
884
dfc2b1be
DK
885insertinstalledpackage() {
886 local NAME="$1"
887 local ARCH="$2"
888 local VERSION="$3"
889 local DEPENDENCIES="$4"
d67004e0 890 local PRIORITY="${5:-optional}"
d4b4e5ea 891 local STATUS="${6:-install ok installed}"
14109555 892 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
893 If you find such a package installed on your system,
894 something went horribly wrong! They are autogenerated
3d284148 895 und used only by testcases and serve no other purpose…"}"
18908589 896
53ea1b56
DK
897 local FILE='rootdir/var/lib/dpkg/status'
898 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 899 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 900 echo "Package: $NAME
d4b4e5ea 901Status: $STATUS
d67004e0 902Priority: $PRIORITY
dfc2b1be
DK
903Section: other
904Installed-Size: 42
905Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
906Version: $VERSION" >> "$FILE"
907 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
908 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
909 echo "Description: $DESCRIPTION" >> "$FILE"
910 echo >> "$FILE"
53ea1b56 911 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
63c71412 912 echo -n > "${INFO}/${NAME}:${arch}.list"
53ea1b56 913 else
63c71412 914 echo -n > "${INFO}/${NAME}.list"
53ea1b56 915 fi
d67004e0 916 done
dfc2b1be
DK
917}
918
919
ce9864a8 920buildaptarchivefromincoming() {
63c71412 921 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
ce9864a8
DK
922 cd aptarchive
923 [ -e pool ] || ln -s ../incoming pool
924 [ -e ftparchive.conf ] || createaptftparchiveconfig
925 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 926 msgninfo "\tGenerate Packages, Sources and Contents files… "
31be38d2 927 testsuccess aptftparchive generate ftparchive.conf
ce9864a8
DK
928 cd - > /dev/null
929 msgdone "info"
4dbfe436 930 generatereleasefiles "$@"
ce9864a8
DK
931}
932
933buildaptarchivefromfiles() {
63c71412 934 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
8d041b4f
DK
935 local DIR='aptarchive'
936 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
937 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
9b78cda6 938 msgninfo "\t${line} file… "
276e51dd 939 compressfile "$line" "$1"
8d876415 940 msgdone "info"
9b78cda6 941 done
e3c62328 942 generatereleasefiles "$@"
9b78cda6
DK
943}
944
276e51dd 945compressfile() {
63c71412 946 cat "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | while read compressor extension command; do
276e51dd
DK
947 if [ "$compressor" = '.' ]; then
948 if [ -n "$2" ]; then
949 touch -d "$2" "$1"
950 fi
951 continue
952 fi
953 cat "$1" | $command > "${1}.${extension}"
954 if [ -n "$2" ]; then
955 touch -d "$2" "${1}.${extension}"
956 fi
957 done
958}
959
a3bbbab7 960# can be overridden by testcases for their pleasure
bf9e7447
DK
961getcodenamefromsuite() {
962 case "$1" in
963 unstable) echo 'sid';;
964 *) echo -n "$1";;
965 esac
966}
a3bbbab7 967getreleaseversionfromsuite() { true; }
718f797c 968getlabelfromsuite() { true; }
d56e2917 969getoriginfromsuite() { true; }
1dd20368 970getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
a3bbbab7 971
c5ede4ca
DK
972aptftparchiverelease() {
973 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
974}
9b78cda6 975generatereleasefiles() {
884a4c0a
DK
976 # $1 is the Date header and $2 is the ValidUntil header to be set
977 # both should be given in notation date/touch can understand
1dd20368
DK
978 local DATE="$1"
979 local VALIDUNTIL="$2"
9b78cda6 980 if [ -e aptarchive/dists ]; then
87d6947d 981 msgninfo "\tGenerate Release files for dists… "
9b78cda6 982 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
1dd20368 983 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
a3bbbab7
DK
984 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
985 local CODENAME="$(getcodenamefromsuite $SUITE)"
986 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 987 local LABEL="$(getlabelfromsuite $SUITE)"
d56e2917 988 local ORIGIN="$(getoriginfromsuite $SUITE)"
63c71412 989 aptftparchiverelease "$dir" \
884a4c0a
DK
990 -o APT::FTPArchive::Release::Suite="${SUITE}" \
991 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
bc7a59dd
DK
992 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
993 -o APT::FTPArchive::Release::Label="${LABEL}" \
994 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
995 -o APT::FTPArchive::Release::Version="${VERSION}" \
63c71412 996 > "$dir/Release"
a3bbbab7 997 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11 998 sed -i '/^Date: / a\
63c71412 999NotAutomatic: yes' "$dir/Release"
35faae11 1000 fi
9b78cda6
DK
1001 done
1002 else
87d6947d 1003 msgninfo "\tGenerate Release files for flat… "
c5ede4ca 1004 aptftparchiverelease ./aptarchive > aptarchive/Release
8d876415 1005 fi
1dd20368 1006 if [ -n "$DATE" -a "$DATE" != "now" ]; then
fe0f7911 1007 for release in $(find ./aptarchive -name 'Release'); do
1dd20368
DK
1008 sed -i "s/^Date: .*$/Date: $(date -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release"
1009 touch -d "$DATE" "$release"
fe0f7911 1010 done
8d876415 1011 fi
1dd20368 1012 if [ -n "$VALIDUNTIL" ]; then
c5ede4ca 1013 sed -i "/^Date: / a\
1dd20368 1014Valid-Until: $(date -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
c5ede4ca 1015 fi
b7899b00 1016 msgdone "info"
8d876415
DK
1017}
1018
b7899b00 1019setupdistsaptarchive() {
63c71412 1020 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
b7899b00
DK
1021 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1022 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1023 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
63c71412 1024 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
b7899b00 1025 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
63c71412
DK
1026 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1027 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
b7899b00
DK
1028 msgdone "info"
1029 done
1030}
1031
1032setupflataptarchive() {
63c71412
DK
1033 local APTARCHIVE="$(readlink -f ./aptarchive)"
1034 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1035 if [ -f "${APTARCHIVE}/Packages" ]; then
8d876415 1036 msgninfo "\tadd deb sources.list line… "
63c71412
DK
1037 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1038 msgdone 'info'
8d876415 1039 else
63c71412 1040 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
8d876415 1041 fi
63c71412 1042 if [ -f "${APTARCHIVE}/Sources" ]; then
8d876415 1043 msgninfo "\tadd deb-src sources.list line… "
63c71412
DK
1044 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1045 msgdone 'info'
8d876415 1046 else
63c71412 1047 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
8d876415 1048 fi
b7899b00
DK
1049}
1050
1051setupaptarchive() {
4dbfe436
DK
1052 local NOUPDATE=0
1053 if [ "$1" = '--no-update' ]; then
1054 NOUPDATE=1
1055 shift
1056 fi
1057 buildaptarchive "$@"
b7899b00
DK
1058 if [ -e aptarchive/dists ]; then
1059 setupdistsaptarchive
1060 else
1061 setupflataptarchive
1062 fi
9d653a6d 1063 signreleasefiles 'Joe Sixpack'
4dbfe436 1064 if [ "1" != "$NOUPDATE" ]; then
5684f71f 1065 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 1066 fi
8d876415
DK
1067}
1068
f213b6ea
DK
1069signreleasefiles() {
1070 local SIGNER="${1:-Joe Sixpack}"
07cb47e7 1071 local REPODIR="${2:-aptarchive}"
f1e1abd8 1072 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
493a813e 1073 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes --digest-algo SHA512"
f1e1abd8 1074 msgninfo "\tSign archive with $SIGNER key $KEY… "
29a59c46
DK
1075 local REXKEY='keys/rexexpired'
1076 local SECEXPIREBAK="${REXKEY}.sec.bak"
1077 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1078 if [ "${SIGNER}" = 'Rex Expired' ]; then
1079 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1080 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1081 # therefore we 'temporary' make the key not expired and restore a backup after signing
63c71412
DK
1082 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1083 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
29a59c46
DK
1084 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1085 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1086 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
63c71412
DK
1087 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1088 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
29a59c46 1089 else
f1e1abd8
DK
1090 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1091 cat setexpire.gpg
1092 exit 1
1093 fi
63c71412
DK
1094 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1095 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
29a59c46
DK
1096 fi
1097 fi
63c71412 1098 for RELEASE in $(find "${REPODIR}/" -name Release); do
785cb6fc 1099 testsuccess $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
e3c62328 1100 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
785cb6fc 1101 testsuccess $GPG --default-key "$SIGNER" --clearsign --output "$INRELEASE" "$RELEASE"
e3c62328 1102 # we might have set a specific date for the Release file, so copy it
63c71412 1103 touch -d "$(stat --format "%y" ${RELEASE})" "${RELEASE}.gpg" "${INRELEASE}"
f213b6ea 1104 done
29a59c46 1105 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
63c71412
DK
1106 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1107 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
29a59c46 1108 fi
63c71412 1109 msgdone 'info'
f213b6ea
DK
1110}
1111
8eafc759
DK
1112redatereleasefiles() {
1113 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1114 for release in $(find aptarchive/ -name 'Release'); do
63c71412
DK
1115 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1116 touch -d "$DATE" "$release"
8eafc759
DK
1117 done
1118 signreleasefiles "${2:-Joe Sixpack}"
1119}
1120
f2c0ec8b 1121webserverconfig() {
6c0765c0 1122 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
b0314abb
DK
1123 local NOCHECK=false
1124 if [ "$1" = '--no-check' ]; then
1125 NOCHECK=true
1126 shift
1127 fi
0d58c26a 1128 local DOWNLOG='rootdir/tmp/download-testfile.log'
b0314abb 1129 local STATUS='downloaded/webserverconfig.status'
0d58c26a 1130 rm -f "$STATUS" "$DOWNLOG"
6c0765c0 1131 # very very basic URI encoding
b0314abb
DK
1132 local URI
1133 if [ -n "$2" ]; then
1134 msgtest "Set webserver config option '${1}' to" "$2"
6c0765c0 1135 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1136 else
1137 msgtest 'Clear webserver config option' "${1}"
6c0765c0 1138 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1139 fi
1140 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
1141 msgpass
1142 else
68042532
DK
1143 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1144 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1145 msgfailoutput '' "$OUTPUT"
f2c0ec8b 1146 fi
b0314abb 1147 $NOCHECK || testwebserverlaststatuscode '200'
f2c0ec8b
DK
1148}
1149
fd46d305 1150rewritesourceslist() {
63c71412 1151 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
af9e40c9 1152 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
fd46d305 1153 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
af9e40c9
DK
1154 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
1155 -e "s#http://localhost:${APTHTTPPORT}/#${1}#" \
1156 -e "s#https://localhost:${APTHTTPSPORT}/#${1}#"
fd46d305
DK
1157 done
1158}
1159
5572f6bd
MV
1160# wait for up to 10s for a pid file to appear to avoid possible race
1161# when a helper is started and dosn't write the PID quick enough
1162waitforpidfile() {
1163 local PIDFILE="$1"
1164 for i in $(seq 10); do
1165 if test -s "$PIDFILE"; then
1166 return 0
1167 fi
1168 sleep 1
1169 done
1170 msgdie "waiting for $PIDFILE failed"
1171 return 1
1172}
1173
f213b6ea 1174changetowebserver() {
6c0765c0 1175 local REWRITE='no'
23af9f40 1176 if [ "$1" != '--no-rewrite' ]; then
6c0765c0 1177 REWRITE='yes'
23af9f40
DK
1178 else
1179 shift
1180 fi
63c71412 1181 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
fbd29dd6 1182 cd aptarchive
a0db467c 1183 local LOG="webserver.log"
6c0765c0 1184 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
3abb6a6a 1185 cat "$LOG"
bee0670b
DK
1186 false
1187 fi
6c0765c0 1188 waitforpidfile aptwebserver.pid
e3c62328
DK
1189 local PID="$(cat aptwebserver.pid)"
1190 if [ -z "$PID" ]; then
1191 msgdie 'Could not fork aptwebserver successfully'
1192 fi
1193 addtrap "kill $PID;"
6c0765c0
DK
1194 waitforpidfile aptwebserver.port
1195 APTHTTPPORT="$(cat aptwebserver.port)"
1196 if [ -z "$APTHTTPPORT" ]; then
1197 msgdie 'Could not get port for aptwebserver successfully'
1198 fi
fbd29dd6 1199 cd - > /dev/null
c5bcc607 1200 else
3d284148 1201 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
f213b6ea 1202 fi
6c0765c0
DK
1203 if [ "$REWRTE" != 'yes' ]; then
1204 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1205 fi
fd46d305
DK
1206}
1207
1208changetohttpswebserver() {
e75e5879 1209 if ! command -v stunnel4 >/dev/null 2>&1; then
fd46d305
DK
1210 msgdie 'You need to install stunnel4 for https testcases'
1211 fi
1212 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1213 changetowebserver --no-rewrite "$@"
fd46d305
DK
1214 fi
1215 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
68ba0b7f 1216cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
23af9f40 1217output = /dev/null
fd46d305
DK
1218
1219[https]
6c0765c0
DK
1220accept = 0
1221connect = $APTHTTPPORT
63c71412 1222" > "${TMPWORKINGDIRECTORY}/stunnel.conf"
fd46d305 1223 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1224 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
63c71412 1225 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
5572f6bd
MV
1226 if [ -z "$PID" ]; then
1227 msgdie 'Could not fork stunnel4 successfully'
1228 fi
fd46d305 1229 addtrap 'prefix' "kill ${PID};"
6c0765c0
DK
1230 APTHTTPSPORT="$(lsof -i | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
1231 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1232 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
f213b6ea
DK
1233}
1234
c45233ea
DK
1235changetocdrom() {
1236 mkdir -p rootdir/media/cdrom/.disk
1237 local CD="$(readlink -f rootdir/media/cdrom)"
63c71412
DK
1238 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1239acquire::cdrom::mount "${CD}";
1240acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1241acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1242acquire::cdrom::autodetect 0;
1243EOF
1244 echo -n "$1" > "${CD}/.disk/info"
c45233ea
DK
1245 if [ ! -d aptarchive/dists ]; then
1246 msgdie 'Flat file archive cdroms can not be created currently'
1247 return 1
1248 fi
a0975c8d 1249 mv aptarchive/dists "$CD"
63c71412 1250 ln -s "$(readlink -f ./incoming)" "$CD/pool"
c45233ea 1251 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1252 # start with an unmounted disk
1253 mv "${CD}" "${CD}-unmounted"
1254 # we don't want the disk to be modifiable
bc8f83a5 1255 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
b0314abb 1256 chmod -R 555 rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1257}
1258
fd46d305 1259downloadfile() {
ed793a19 1260 local PROTO="${1%%:*}"
27925d82 1261 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
dcbb364f 1262 download-file "$1" "$2" "$3" 2>&1 ; then
27925d82
DK
1263 return 1
1264 fi
fd46d305 1265 # only if the file exists the download was successful
b0314abb 1266 if [ -r "$2" ]; then
fd46d305
DK
1267 return 0
1268 else
1269 return 1
1270 fi
1271}
1272
f213b6ea 1273checkdiff() {
03aa0847 1274 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1275 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1276 echo >&2
1277 echo >&2 "$DIFFTEXT"
8d876415
DK
1278 return 1
1279 else
1280 return 0
1281 fi
1282}
1283
22ac12b2
DK
1284testoutputequal() {
1285 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1286 local COMPAREFILE="$1"
1287 shift
63c71412 1288 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
22ac12b2
DK
1289 msgpass
1290 else
1291 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1292 cat "$COMPAREFILE" >>"${OUTPUT}"
1293 msgfailoutput '' "$OUTPUT" "$@"
1294 fi
1295}
1296
75954ae2 1297testfileequal() {
1501a2c9 1298 msggroup 'testfileequal'
e6a12ff7
DK
1299 local MSG='Test for correctness of file'
1300 if [ "$1" = '--nomsg' ]; then
1301 MSG=''
1302 shift
1303 fi
75954ae2
DK
1304 local FILE="$1"
1305 shift
e6a12ff7
DK
1306 if [ -n "$MSG" ]; then
1307 msgtest "$MSG" "$FILE"
1308 fi
68042532 1309 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
75954ae2 1310 if [ -z "$*" ]; then
22ac12b2 1311 testoutputequal "$FILE" echo -n ''
75954ae2 1312 else
22ac12b2 1313 testoutputequal "$FILE" echo "$*"
75954ae2 1314 fi
9beb11aa 1315 msggroup
75954ae2
DK
1316}
1317
b855a400 1318testempty() {
1501a2c9 1319 msggroup 'testempty'
a66e1837
DK
1320 if [ "$1" = '--nomsg' ]; then
1321 shift
1322 else
1323 msgtest "Test for no output of" "$*"
1324 fi
859093da 1325 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
a66e1837 1326 if "$@" >"$COMPAREFILE" 2>&1 && test ! -s "$COMPAREFILE"; then
859093da
DK
1327 msgpass
1328 else
22ac12b2 1329 msgfailoutput '' "$COMPAREFILE" "$@"
859093da 1330 fi
ab25bf1f 1331 aptautotest 'testempty' "$@"
9beb11aa 1332 msggroup
b855a400 1333}
63c71412
DK
1334testnotempty() {
1335 msggroup 'testnotempty'
1336 msgtest "Test for some output of" "$*"
1337 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1338 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1339 msgpass
1340 else
1341 msgfailoutput '' "$COMPAREFILE" "$@"
1342 fi
1343 aptautotest 'testnotempty' "$@"
1344 msggroup
1345}
b855a400 1346
f74a6fa1 1347testequal() {
1501a2c9 1348 msggroup 'testequal'
f74a6fa1
DK
1349 local MSG='Test of equality of'
1350 if [ "$1" = '--nomsg' ]; then
1351 MSG=''
1352 shift
1353 fi
1354
03938280 1355 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
63c71412 1356 echo "$1" > "$COMPAREFILE"
8d876415 1357 shift
d2d68aaf 1358
f74a6fa1
DK
1359 if [ -n "$MSG" ]; then
1360 msgtest "$MSG" "$*"
1361 fi
22ac12b2 1362 testoutputequal "$COMPAREFILE" "$@"
ab25bf1f 1363 aptautotest 'testequal' "$@"
9beb11aa 1364 msggroup
8d876415
DK
1365}
1366
685625bd 1367testequalor2() {
1501a2c9 1368 msggroup 'testequalor2'
03938280
DK
1369 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1370 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1371 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
63c71412
DK
1372 echo "$1" > "$COMPAREFILE1"
1373 echo "$2" > "$COMPAREFILE2"
685625bd
DK
1374 shift 2
1375 msgtest "Test for equality OR of" "$*"
63c71412
DK
1376 "$@" >"$COMPAREAGAINST" 2>&1 || true
1377 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1378 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
0d58c26a 1379 then
0caa5a4c
DK
1380 msgpass
1381 else
68042532
DK
1382 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1383 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1384 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1385 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1386 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1387 msgfailoutput '' "$OUTPUT"
0caa5a4c 1388 fi
ab25bf1f 1389 aptautotest 'testequalor2' "$@"
9beb11aa 1390 msggroup
685625bd
DK
1391}
1392
8d876415 1393testshowvirtual() {
1501a2c9 1394 msggroup 'testshowvirtual'
edc0ef10 1395 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1396 local PACKAGE="$1"
1397 shift
1398 while [ -n "$1" ]; do
1399 VIRTUAL="${VIRTUAL}
edc0ef10 1400N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1401 PACKAGE="${PACKAGE} $1"
1402 shift
1403 done
1404 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1405 VIRTUAL="${VIRTUAL}
4bec02c2 1406N: No packages found"
03938280 1407 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1408 local ARCH="$(getarchitecture 'native')"
68042532
DK
1409 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1410 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
87d6947d 1411 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
9beb11aa 1412 msggroup
8d876415
DK
1413}
1414
1415testnopackage() {
1501a2c9 1416 msggroup 'testnopackage'
8d876415 1417 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1418 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1419 if [ -n "$SHOWPKG" ]; then
68042532
DK
1420 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1421 echo "$SHOWPKG" >"$OUTPUT"
1422 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1423 else
1424 msgpass
8d876415 1425 fi
9beb11aa 1426 msggroup
8d876415 1427}
bd4a8f51
DK
1428testnosrcpackage() {
1429 msggroup 'testnosrcpackage'
1430 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1431 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1432 if [ -n "$SHOWPKG" ]; then
1433 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1434 echo "$SHOWPKG" >"$OUTPUT"
1435 msgfailoutput '' "$OUTPUT"
1436 else
1437 msgpass
1438 fi
1439 msggroup
1440}
01a6e24c 1441
ecb777dd 1442testdpkgstatus() {
1501a2c9 1443 msggroup 'testdpkgstatus'
ecb777dd
DK
1444 local STATE="$1"
1445 local NR="$2"
1446 shift 2
1447 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1448 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1449 if [ "$PKGS" != $NR ]; then
68042532
DK
1450 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1451 echo "$PKGS" >"$OUTPUT"
1452 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1453 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1454 else
1455 msgpass
01a6e24c 1456 fi
9beb11aa 1457 msggroup
01a6e24c
DK
1458}
1459
ecb777dd 1460testdpkginstalled() {
1501a2c9 1461 msggroup 'testdpkginstalled'
ecb777dd 1462 testdpkgstatus 'ii' "$#" "$@"
9beb11aa 1463 msggroup
ecb777dd
DK
1464}
1465
5cf733e1 1466testdpkgnotinstalled() {
1501a2c9 1467 msggroup 'testdpkgnotinstalled'
ecb777dd 1468 testdpkgstatus 'ii' '0' "$@"
9beb11aa 1469 msggroup
01a6e24c 1470}
ec7f904e
DK
1471
1472testmarkedauto() {
1501a2c9 1473 msggroup 'testmarkedauto'
03938280 1474 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1475 if [ -n "$1" ]; then
1476 msgtest 'Test for correctly marked as auto-installed' "$*"
63c71412 1477 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
ec7f904e
DK
1478 else
1479 msgtest 'Test for correctly marked as auto-installed' 'no package'
63c71412 1480 echo -n > "$COMPAREFILE"
ec7f904e 1481 fi
22ac12b2 1482 testoutputequal "$COMPAREFILE" aptmark showauto
9beb11aa 1483 msggroup
ec7f904e 1484}
7c2cc4a7 1485testmarkedmanual() {
1501a2c9 1486 msggroup 'testmarkedmanual'
7c2cc4a7
DK
1487 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1488 if [ -n "$1" ]; then
1489 msgtest 'Test for correctly marked as manually installed' "$*"
63c71412 1490 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
7c2cc4a7
DK
1491 else
1492 msgtest 'Test for correctly marked as manually installed' 'no package'
63c71412 1493 echo -n > "$COMPAREFILE"
7c2cc4a7 1494 fi
22ac12b2 1495 testoutputequal "$COMPAREFILE" aptmark showmanual
9beb11aa 1496 msggroup
7c2cc4a7 1497}
89a1aa5d 1498
e52aad52 1499msgfailoutput() {
1501a2c9 1500 msgreportheader 'msgfailoutput'
e52aad52
DK
1501 local MSG="$1"
1502 local OUTPUT="$2"
1503 shift 2
e52aad52 1504 if [ "$1" = 'grep' ]; then
68042532 1505 echo >&2
e52aad52
DK
1506 while [ -n "$2" ]; do shift; done
1507 echo "#### Complete file: $1 ####"
1508 cat >&2 "$1" || true
1509 echo '#### grep output ####'
1510 elif [ "$1" = 'test' ]; then
68042532 1511 echo >&2
e52aad52
DK
1512 # doesn't support ! or non-file flags
1513 msgfailoutputstatfile() {
1514 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1515 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1516 echo "#### stat(2) of file: $2 ####"
1517 stat "$2" || true
dffc17ba
DK
1518 if test -d "$2"; then
1519 echo "#### The directory contains: $2 ####"
1520 ls >&2 "$2" || true
1521 elif test -e "$2"; then
3196dae8
DK
1522 echo "#### Complete file: $2 ####"
1523 cat >&2 "$2" || true
1524 fi
e52aad52
DK
1525 fi
1526 }
1527 msgfailoutputstatfile "$2" "$3"
1528 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1529 shift 3
1530 msgfailoutputstatfile "$2" "$3"
1531 done
1532 echo '#### test output ####'
6fc2e030
DK
1533 elif [ "$1" = 'cmp' ]; then
1534 echo >&2
1535 while [ -n "$2" ]; do
1536 echo "#### Complete file: $2 ####"
1537 cat >&2 "$2" || true
1538 shift
1539 done
1540 echo '#### cmp output ####'
e52aad52 1541 fi
63c71412 1542 cat >&2 "$OUTPUT"
e52aad52
DK
1543 msgfail "$MSG"
1544}
1545
671a55ba
DK
1546testsuccesswithglobalerror() {
1547 local TYPE="$1"
1548 local ERRORS="$2"
1549 shift 2
1550 msggroup "$TYPE"
0440d936
DK
1551 if [ "$1" = '--nomsg' ]; then
1552 shift
1553 else
1554 msgtest 'Test for successful execution of' "$*"
1555 fi
671a55ba 1556 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
63c71412 1557 if "$@" >"${OUTPUT}" 2>&1; then
4fa34122 1558 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1559 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1560 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
671a55ba 1561 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
3261271e
DK
1562 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1563 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1564 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1565 msgpass
1566 else
1567 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1568 fi
1569 else
1570 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1571 fi
671a55ba
DK
1572 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1573 if grep -q -E "^N: " "$OUTPUT"; then
1574 msgpass
1575 else
1576 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1577 fi
4fa34122
DK
1578 else
1579 msgpass
1580 fi
1581 else
1582 msgpass
1583 fi
1584 else
1585 local EXITCODE=$?
e52aad52 1586 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
4fa34122 1587 fi
671a55ba 1588 aptautotest "$TYPE" "$@"
9beb11aa 1589 msggroup
4fa34122 1590}
671a55ba
DK
1591testsuccesswithnotice() {
1592 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1593}
1594testsuccess() {
1595 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1596}
4fa34122 1597testwarning() {
1501a2c9 1598 msggroup 'testwarning'
4fa34122
DK
1599 if [ "$1" = '--nomsg' ]; then
1600 shift
1601 else
1602 msgtest 'Test for successful execution with warnings of' "$*"
1603 fi
25b86db1 1604 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
63c71412 1605 if "$@" >"${OUTPUT}" 2>&1; then
1df24acf 1606 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1607 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1608 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1609 elif grep -q -E '^E: ' "$OUTPUT"; then
1610 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
4fa34122 1611 elif ! grep -q -E '^W: ' "$OUTPUT"; then
e52aad52 1612 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1df24acf
DK
1613 else
1614 msgpass
1615 fi
1616 else
1617 msgpass
1618 fi
0440d936 1619 else
07cb47e7 1620 local EXITCODE=$?
68042532 1621 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1622 fi
4fa34122 1623 aptautotest 'testwarning' "$@"
9beb11aa 1624 msggroup
0440d936 1625}
0440d936 1626testfailure() {
1501a2c9 1627 msggroup 'testfailure'
0440d936
DK
1628 if [ "$1" = '--nomsg' ]; then
1629 shift
1630 else
889b0072 1631 msgtest 'Test for failure in execution of' "$*"
0440d936 1632 fi
03938280 1633 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
63c71412 1634 if "$@" >"${OUTPUT}" 2>&1; then
07cb47e7 1635 local EXITCODE=$?
e52aad52 1636 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1637 else
1df24acf
DK
1638 local EXITCODE=$?
1639 if expr match "$1" '^apt.*' >/dev/null; then
b0d40854
DK
1640 if [ "$1" = 'aptkey' ]; then
1641 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1642 grep -q -E " BAD signature from " "$OUTPUT"; then
1643 msgpass
1644 else
1645 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1646 fi
1df24acf 1647 else
b0d40854
DK
1648 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1649 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1650 elif grep -q -E '==ERROR' "$OUTPUT"; then
1651 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1652 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1653 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1654 else
1655 msgpass
1656 fi
1df24acf
DK
1657 fi
1658 else
1659 msgpass
1660 fi
0440d936 1661 fi
ab25bf1f 1662 aptautotest 'testfailure' "$@"
9beb11aa 1663 msggroup
0440d936
DK
1664}
1665
7414af7f
DK
1666testreturnstateequal() {
1667 local STATE="$1"
671a55ba
DK
1668 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1669 local STATE="$2"
1670 local TYPE="$3"
7414af7f 1671 shift 3
671a55ba
DK
1672 msggroup "${STATE}equal"
1673 if [ "$1" != '--nomsg' ]; then
1674 local CMP="$1"
1675 shift
1676 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1677 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1678 else
1679 local CMP="$2"
1680 shift 2
1681 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1682 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1683 fi
1684 else
1685 msggroup "${STATE}equal"
1686 if [ "$2" != '--nomsg' ]; then
1687 local CMP="$2"
1688 shift 2
1689 "$STATE" "$@"
1690 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1691 else
1692 local CMP="$3"
1693 shift 3
1694 "$STATE" --nomsg "$@"
1695 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1696 fi
7414af7f 1697 fi
9beb11aa 1698 msggroup
25b86db1 1699}
7414af7f 1700testsuccessequal() {
671a55ba
DK
1701 # we compare output, so we know perfectly well about N:
1702 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
7414af7f 1703}
25b86db1 1704testwarningequal() {
7414af7f 1705 testreturnstateequal 'testwarning' "$@"
25b86db1
DK
1706}
1707testfailureequal() {
7414af7f 1708 testreturnstateequal 'testfailure' "$@"
25b86db1
DK
1709}
1710
27925d82 1711testfailuremsg() {
1501a2c9 1712 msggroup 'testfailuremsg'
27925d82
DK
1713 local CMP="$1"
1714 shift
1715 testfailure "$@"
1716 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
68042532 1717 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
002b1bc4 1718 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
22ac12b2 1719 testoutputequal "$COMPAREFILE" echo "$CMP"
9beb11aa 1720 msggroup
27925d82 1721}
f18f2338
DK
1722testwarningmsg() {
1723 msggroup 'testwarningmsg'
1724 local CMP="$1"
1725 shift
1726 testwarning "$@"
1727 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1728 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
002b1bc4 1729 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
f18f2338
DK
1730 testoutputequal "$COMPAREFILE" echo "$CMP"
1731 msggroup
1732}
25b86db1 1733
de81b2e2 1734testfilestats() {
1501a2c9 1735 msggroup 'testfilestats'
de81b2e2
DK
1736 msgtest "Test that file $1 has $2 $3" "$4"
1737 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
5684f71f
DK
1738 msgpass
1739 else
68042532
DK
1740 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1741 {
1742 ls -ld "$1" || true
1743 echo -n "stat(1) reports for $2: "
1744 stat --format "$2" "$1" || true
1745 } >"$OUTPUT" 2>&1
1746 msgfailoutput '' "$OUTPUT"
5684f71f 1747 fi
9beb11aa 1748 msggroup
5684f71f 1749}
de81b2e2 1750testaccessrights() {
1501a2c9 1751 msggroup 'testaccessrights'
de81b2e2 1752 testfilestats "$1" '%a' '=' "$2"
9beb11aa 1753 msggroup
de81b2e2 1754}
5684f71f 1755
0d58c26a 1756testwebserverlaststatuscode() {
1501a2c9 1757 msggroup 'testwebserverlaststatuscode'
0d58c26a 1758 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
03aa0847 1759 local STATUS='downloaded/webserverstatus-statusfile.log'
0d58c26a
DK
1760 rm -f "$DOWNLOG" "$STATUS"
1761 msgtest 'Test last status code from the webserver was' "$1"
6c0765c0 1762 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
0d58c26a
DK
1763 msgpass
1764 else
68042532
DK
1765 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1766 {
1767 if [ -n "$2" ]; then
1768 shift
1769 echo >&2 '#### Additionally provided output files contain:'
1770 cat >&2 "$@"
1771 fi
1772 echo >&2 '#### Download log of the status code:'
1773 cat >&2 "$DOWNLOG"
1774 } >"$OUTPUT" 2>&1
1775 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
0d58c26a 1776 fi
9beb11aa 1777 msggroup
0d58c26a
DK
1778}
1779
785cb6fc
DK
1780createlistofkeys() {
1781 local OUTPUT="$1"
1782 shift
1783 while [ -n "$1" ]; do
eb5113c4
JAK
1784 # gpg 2.1.something starts printing [SC] at some point
1785 if grep -q ' rsa2048/' "$OUTPUT" && grep -qF '[SC]' "$OUTPUT"; then
1786 case "$1" in
1787 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1788 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [SC] [expired: 2013-07-13]';;
1789 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16 [SC]';;
1790 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19 [SC]';;
1791 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1792 *) echo 'UNKNOWN KEY';;
1793 esac
785cb6fc 1794 # gpg 2.1 has a slightly different output format
eb5113c4 1795 elif grep -q ' rsa2048/' "$OUTPUT"; then
785cb6fc
DK
1796 case "$1" in
1797 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1798 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1799 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';;
1800 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';;
1801 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1802 *) echo 'UNKNOWN KEY';;
1803 esac
1804 else
1805 case "$1" in
1806 *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1807 *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1808 *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';;
1809 oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';;
1810 newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1811 *) echo 'UNKNOWN KEY';;
1812 esac
1813 fi
1814 shift
1815 done
1816}
1817testaptkeys() {
1818 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
1819 if ! aptkey list | grep '^pub' > "$OUTPUT"; then
1820 echo -n > "$OUTPUT"
1821 fi
1822 testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")"
1823}
1824
89a1aa5d
DK
1825pause() {
1826 echo "STOPPED execution. Press enter to continue"
1827 local IGNORE
1828 read IGNORE
1829}
ab25bf1f 1830
846bc058 1831listcurrentlistsdirectory() {
ba6b79bd
DK
1832 {
1833 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1834 stat --format '%U:%G:%a:%n' "$line"
1835 done
1836 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1837 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1838 done
1839 } | sort
846bc058 1840}
912a6131
DK
1841forallsupportedcompressors() {
1842 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
0179cfa8 1843 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
912a6131
DK
1844 "$@" "$COMP"
1845 done
1846}
846bc058 1847
3a8776a3 1848### convenience hacks ###
8fe964f1
DK
1849mkdir() {
1850 # creating some directories by hand is a tedious task, so make it look simple
6aef1942
DK
1851 local PARAMS="$*"
1852 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
8fe964f1
DK
1853 # only the last directory created by mkdir is effected by the -m !
1854 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1855 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1856 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1857 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1858 if [ "$(id -u)" = '0' ]; then
1859 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1860 fi
1861 else
1862 command mkdir "$@"
1863 fi
1864}
1865
ab25bf1f
DK
1866### The following tests are run by most test methods automatically to check
1867### general things about commands executed without writing the test every time.
1868
1869aptautotest() {
1870 local TESTCALL="$1"
1871 local CMD="$2"
1872 local FIRSTOPT="$3"
896f0ae8 1873 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
ab25bf1f
DK
1874 if command -v $AUTOTEST >/dev/null; then
1875 shift 3
1876 # save and restore the *.output files from other tests
1877 # as we might otherwise override them in these automatic tests
63c71412
DK
1878 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1879 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1880 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f 1881 $AUTOTEST "$TESTCALL" "$@"
63c71412
DK
1882 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1883 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1884 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f
DK
1885 fi
1886}
1887
1888aptautotest_aptget_update() {
59148d96
DK
1889 local TESTCALL="$1"
1890 while [ -n "$2" ]; do
1891 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1892 shift
1893 done
ab25bf1f 1894 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
4bb006d1
DK
1895 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1896 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
ab25bf1f 1897 # all copied files are properly chmodded
63c71412
DK
1898 local backupIFS="$IFS"
1899 IFS="$(printf "\n\b")"
146f7715 1900 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
4bb006d1 1901 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
ab25bf1f 1902 done
63c71412 1903 IFS="$backupIFS"
59148d96 1904 if [ "$TESTCALL" = 'testsuccess' ]; then
146f7715
DK
1905 # failure cases can retain partial files and such
1906 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1907 fi
ab25bf1f
DK
1908}
1909aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
d84da499 1910aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
016bea82
DK
1911
1912testaptautotestnodpkgwarning() {
1913 local TESTCALL="$1"
1914 while [ -n "$2" ]; do
6bf93605
DK
1915 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1916 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
016bea82
DK
1917 shift
1918 done
1919 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1920}
1921
1922aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1923aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1924aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1925aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1926aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1927aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }